﻿/**
Carlos de Olivera Junior
http://www.vamoss.com.br/blogfolio/?p=263
Follow me @vamoss
**/

package {
	
	import flash.events.MouseEvent;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	
	import org.papervision3d.lights.PointLight3D;
	import org.papervision3d.materials.BitmapFileMaterial;
	import org.papervision3d.materials.BitmapMaterial;
	import org.papervision3d.materials.utils.MaterialsList;
	import org.papervision3d.objects.special.DAEMC2;
	import net.saqoosha.flartoolkit.example.PV3DARApp;
	import org.papervision3d.events.FileLoadEvent;
	

	[SWF(width=640,height=480,frameRate=12,backgroundColor=0x0)]

	public class Main extends PV3DARApp {
		
		private static const PATTERN_FILE:String = "Data/basic.patt";
		private static const CAMERA_FILE:String = "Data/camera_para.dat";
		
		public var daeFile:DAEMC2;
		public var luz:PointLight3D;
		public var material:BitmapFileMaterial;
		
		public function Main() {
			this.addEventListener(Event.INIT, this._onInit);
			this.init(CAMERA_FILE, PATTERN_FILE);
		}
		
		private function _onInit(e:Event):void {
			this.removeEventListener(Event.INIT, this._onInit);
			
			//Luz
			luz = new PointLight3D(true);
            luz.z = 1000;
            luz.y = -500;
            luz.x = 1000;
			
			//Material
			material = new BitmapFileMaterial("scout_flat.jpg");
			material.doubleSided = false;
			material.smooth = true;

			//DAEMC2
			daeFile = new DAEMC2(true, null, 0);
			daeFile.load("model.DAE", new MaterialsList( { scout_red: material } ));
			daeFile.addEventListener(FileLoadEvent.ANIMATIONS_COMPLETE, addIt2Stage);
		}
				
		protected function addIt2Stage(e:FileLoadEvent):void 
		{
			this._baseNode.addChild(daeFile);
			this.mirror = !this.mirror;
			
			daeFile.scale = 0.5;
			daeFile.rotationX=-90;
			daeFile.rotationY=180;
		   
			daeFile.currentFrameNumber = 1;
			daeFile.play();
			
			daeFile.addFrameScript(31, doLoop);
			daeFile.addFrameScript(13, doWalk);
			daeFile.currentFrameNumber = 24;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN,keyDownListener);
			stage.addEventListener(KeyboardEvent.KEY_UP,keyUpListener);
		}
		
		private function doLoop():void{
			daeFile.currentFrameNumber = 24;
			daeFile.play();
		}
		
		private function doWalk():void{
			if(daeFile.currentFrameNumber>=13){
				daeFile.currentFrameNumber = 1;
				daeFile.play();
			}
		}
		
		private function doWalkReverse():void{
			if(daeFile.currentFrameNumber>=13){
				daeFile.currentFrameNumber = 13;
				daeFile.play();
			}
		}
		
		private function keyDownListener(e:KeyboardEvent):void {

			//trace("e.keyCode=" + e.keyCode);

			//This is a bad exemple, if you change this, send to me, I am developing this yet.
			//Thanks, http://www.vamoss.com.br/blogfolio/?p=263

			if (e.keyCode==37) {//Left
				daeFile.rotationZ-=5;
			}else if (e.keyCode==39) {//Right
				daeFile.rotationZ+=5;
			}
			
			if (e.keyCode==38) {//Up
				daeFile.moveBackward(15);
				doWalk();
			}else if (e.keyCode==40) {//Down
				daeFile.moveForward(15);
				daeFile.inReverse = true;
				doWalkReverse();
			}
			
			if (e.keyCode==32) {//Space
				daeFile.currentFrameNumber = 13;
				daeFile.play();
			}
			
		}
		
		private function keyUpListener(e:KeyboardEvent):void {
			if (e.keyCode!=32) {//Space
				daeFile.inReverse = false;
				doLoop();
			}		
		}
	}
}